#include "pch.h"
#include <iostream>
#include <ctime>
#include <utility>
#include <vector>
#include <list>
#include <string>

using namespace std;

class Date
{
private:
	short day;
	short month;
	unsigned int year;
public:
	Date() : day(1), month(1), year(1900)
	{
		
	}
	Date(short day, short month, unsigned int year) : day(day), month(month), year(year)
	{
	}

	double get_age()
	{
		struct tm newtime;
		__time64_t long_time;
		_time64(&long_time);
		auto err = _localtime64_s(&newtime, &long_time);
		if(err)
		{
			printf("Invalid argument to _localtime_s");
			return 0;
		}
		return newtime.tm_year - (year - 1900);
	}
};


class Employee
{
private:
public:
	Employee(string name, string first_name, short day, short month, unsigned int year) : name(move(name)), first_name(move(first_name)), taken_holidays(0)
	{
		day_of_birth = Date(day, month, year);
		auto age = day_of_birth.get_age();
		holidays = age > 50 ? 32 : 30;
	}

	string name;
	string first_name;
	Date day_of_birth;
	int holidays;
	int taken_holidays;
};

static list<Employee> employees;

void create_employee();

int main()
{
	auto end_program = false;
	while (!end_program)
	{
		system("cls");
		cout << "Urlaubsverwaltung" << endl << endl;
		cout << "Bitte whlen Sie eine Option:" << endl;
		cout << "1: Mitarbeiter anlegen" << endl;
		cout << "2: Mitarbeiter lschen" << endl;
		cout << "3: Urlaub eingeben" << endl;
		cout << "4: Mitarbeiter suchen" << endl;
		cout << "5: Alle Mitarbeiter auflisten" << endl;
		cout << "0: Programm beenden" << endl;
		cout << "ihre Eingabe:";
		auto input = 0;
		cin >> input;

		switch (input)
		{
		case 1:
			create_employee();
			break;
		case 2:
			break;
		case 3:
			break;
		case 4:
			break;
		case 5:
			break;
		case 0:
			end_program = true;
			break;
		default:
			cout << "Unerlaubte Eingabe" << endl;
			system("pause");
		}
	}
}

void create_employee()
{
	while (true)
	{
		string name;
		string first_name;
		cout << "Bitte einen Namen eingeben: ";
		cin >> name;
		cout << "Bitte einen Vornamen eingeben: ";
		cin >> first_name;
		cout << "Bitte das Geburtsdatum eingeben: " << endl;
		short day;
		cout << "Tag: ";
		cin >> day;
		short month;
		cout << "Monat: ";
		cin >> month;
		unsigned int year;
		cout << "Jahr: ";
		cin >> year;
		employees.emplace_back(name, first_name, day, month, year);
		cout << "Einen weiteren Benutzer eingeben? [J/N]" << endl;
		string input;
		cin >> input;
		if (input._Equal("N")|| input._Equal("n")) break;
	}
}
